# Poco::Util

# class Timer

Library: Util
Package: Timer
Header: Poco/Util/Timer.h

## Description

A Timer allows to schedule tasks (TimerTask objects) for future execution in a background thread. Tasks may be scheduled for one-time execution, or for repeated execution at regular intervals.

The Timer object creates a thread that executes all scheduled tasks sequentially. Therefore, tasks should complete their work as quickly as possible, otherwise subsequent tasks may be delayed.

Timer is save for multithreaded use - multiple threads can schedule new tasks simultaneously.

Acknowledgement: The interface of this class has been inspired by the java.util.Timer class from Java 1.3.

## Inheritance

Direct Base Classes: Poco::Runnable

All Base Classes: Poco::Runnable

## Member Summary

Member Functions: cancel, run, schedule, scheduleAtFixedRate

Inherited Functions: run

## Constructors

### Timer

Timer();

Creates the Timer.

### Timer

explicit Timer(
Poco::Thread::Priority priority
);

Creates the Timer, using a timer thread with the given priority.

## Destructor

### ~Timer

~Timer();

Destroys the Timer, cancelling all pending tasks.

## Member Functions

### cancel

void cancel();

Cancels all pending tasks.

If a task is currently running, it is allowed to finish.

### schedule

void schedule(
TimerTask::Ptr pTask,
Poco::Timestamp time
);

Schedules a task for execution at the specified time.

If the time lies in the past, the task is executed immediately.

### schedule

void schedule(
TimerTask::Ptr pTask,
long delay,
long interval
);

Schedules a task for periodic execution.

The task is first executed after the given delay. Subsequently, the task is executed periodically with the given interval in milliseconds between invocations.

### schedule

void schedule(
TimerTask::Ptr pTask,
Poco::Timestamp time,
long interval
);

Schedules a task for periodic execution.

The task is first executed at the given time. Subsequently, the task is executed periodically with the given interval in milliseconds between invocations.

### scheduleAtFixedRate

void scheduleAtFixedRate(
TimerTask::Ptr pTask,
long delay,
long interval
);

Schedules a task for periodic execution at a fixed rate.

The task is first executed after the given delay. Subsequently, the task is executed periodically every number of milliseconds specified by interval.

If task execution takes longer than the given interval, further executions are delayed.

### scheduleAtFixedRate

void scheduleAtFixedRate(
TimerTask::Ptr pTask,
Poco::Timestamp time,
long interval
);

Schedules a task for periodic execution at a fixed rate.

The task is first executed at the given time. Subsequently, the task is executed periodically every number of milliseconds specified by interval.

If task execution takes longer than the given interval, further executions are delayed.

### run

void run();

See also: Poco::Runnable::run()